//+------------------------------------------------------------------+
//|                                                   Price Flow.mq4 |
//|                             Copyright 2007-2016, FinanceWave.com |
//|                                       http://www.financewave.com |
//+------------------------------------------------------------------+
#property copyright   "2007-2016, FinanceWave.com"
#property link        "http://www.financewave.com"
#property description "Price Flow"

double sit=0;
int comeco = 1;
double pbuy = 0;
double psell = 1000000000;
double Accounttp = 0;
int inic=0;
double lotbuy=0;
double lotsell=0;
extern double Lots=0.01;
double LotsIN=Lots;
extern int MARTINGALE=0;
extern int EXPONENTIAL=1;
double lots2=Lots;
extern double pippoints = 50;
extern double risk = 0.02;
extern int HOURBEGIN = 14;
extern int HOURFINISH = 19;
extern int MINUTEBEGIN = 43;
extern int MINUTEFINISH = 42;

int inicio=0;

extern int slippageOPTION = 3;
extern int rr = 1;

double prof = pippoints*(MarketInfo(NULL,MODE_TICKVALUE)*MarketInfo(NULL,MODE_MINLOT));
int cnt;
double sumloss;
double inv;
double ninv;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick(void)
  {

//////////////////////////EXPONENTIAL && NO MARTINGALE
if(EXPONENTIAL==1 && MARTINGALE==0)
{

if(Hour()==HOURBEGIN && Minute()==MINUTEBEGIN)
{inic=1;}

if(Hour()==HOURFINISH && Minute()==MINUTEFINISH)
{inic=0;
for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
{
if(!OrderDelete(OrderTicket(),Violet))
Print("OrderDelete error ",GetLastError());
}
else if(OrderType()==OP_SELL)
{
if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
else if(OrderType()==OP_BUY)
{
if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
}
}

if(inic==1)
{

int ticket, ticket2;

   if(MarketInfo(NULL,MODE_MINLOT)==0.01){int digits = 2;}
   else if(MarketInfo(NULL,MODE_MINLOT)==0.1){digits = 1;}
   else if(MarketInfo(NULL,MODE_MINLOT)==1){digits = 0;}
   double spread = MarketInfo(NULL,MODE_SPREAD);
   double minpipvalue = MarketInfo(NULL,MODE_TICKVALUE)*MarketInfo(NULL,MODE_MINLOT);

double mpv = MarketInfo(NULL,MODE_TICKVALUE)*MarketInfo(NULL,MODE_MINLOT);
double sp = MarketInfo(NULL,MODE_SPREAD);

if(sit==0)
{

if(comeco==1)
{
   double fator = (pippoints*Point)*(1/Point)*minpipvalue;
   Lots = NormalizeDouble(((AccountFreeMargin()*risk)/fator)*MarketInfo(Symbol(), MODE_MINLOT),digits);
   if(Lots<MarketInfo(NULL,MODE_MINLOT)){Lots=MarketInfo(NULL,MODE_MINLOT);}

lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(int n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUY,MarketInfo(NULL,MODE_MAXLOT),Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,MarketInfo(NULL,MODE_MAXLOT),Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUY,lots2,Ask,0,Ask-pippoints*Point,slippageOPTION,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,lots2,Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);

pbuy = Ask;
psell = Ask-pippoints*Point;
sit=1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}

if(comeco==-1)
{
   fator = (pippoints*Point)*(1/Point)*minpipvalue;
   Lots = NormalizeDouble(((AccountFreeMargin()*risk)/fator)*MarketInfo(Symbol(), MODE_MINLOT),digits);
   if(Lots<MarketInfo(NULL,MODE_MINLOT)){Lots=MarketInfo(NULL,MODE_MINLOT);}

lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,MarketInfo(NULL,MODE_MAXLOT),Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,MarketInfo(NULL,MODE_MAXLOT),Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUYSTOP,lots2,Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,lots2,Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
pbuy = Bid+pippoints*Point;
psell = Bid;
sit=-1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}
}

for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELL && sit>=1)
{
pbuy = pbuy+pippoints*Point;
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,MarketInfo(NULL,MODE_MAXLOT),pbuy,slippageOPTION,psell-pippoints*Point,0,"Hedge HFT",20000,0,Green);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUYSTOP,lots2,pbuy,slippageOPTION,psell-pippoints*Point,0,"Hedge HFT",20000,0,Green);
sit=-sit-1;
}
if(OrderType()==OP_BUY && sit<=-1)
{
psell = psell-pippoints*Point;
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket2=OrderSend(Symbol(),OP_SELLSTOP,MarketInfo(NULL,MODE_MAXLOT),psell,slippageOPTION,pbuy+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket2=OrderSend(Symbol(),OP_SELLSTOP,lots2,psell,slippageOPTION,pbuy+pippoints*Point,0,"Hedge HFT",40000,0,Red);
sit=-sit+1;
}
}

if(AccountBalance()+AccountProfit()>=Accounttp)
{
for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
{
if(!OrderDelete(OrderTicket(),Violet))
Print("OrderDelete error ",GetLastError());
}
else if(OrderType()==OP_SELL)
{
if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
else if(OrderType()==OP_BUY)
{
if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
}
if(sit>0)
{comeco = 1;}
if(sit<0)
{comeco = -1;}
sit=0;

if(comeco==1)
{
   fator = (pippoints*Point)*(1/Point)*minpipvalue;
   Lots = NormalizeDouble(((AccountFreeMargin()*risk)/fator)*MarketInfo(Symbol(), MODE_MINLOT),digits);
   if(Lots<MarketInfo(NULL,MODE_MINLOT)){Lots=MarketInfo(NULL,MODE_MINLOT);}

lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUY,MarketInfo(NULL,MODE_MAXLOT),Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,MarketInfo(NULL,MODE_MAXLOT),Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUY,lots2,Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,lots2,Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);

pbuy = Ask;
psell = Ask-pippoints*Point;
sit=1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}

if(comeco==-1)
{
   fator = (pippoints*Point)*(1/Point)*minpipvalue;
   Lots = NormalizeDouble(((AccountFreeMargin()*risk)/fator)*MarketInfo(Symbol(), MODE_MINLOT),digits);
   if(Lots<MarketInfo(NULL,MODE_MINLOT)){Lots=MarketInfo(NULL,MODE_MINLOT);}

lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,MarketInfo(NULL,MODE_MAXLOT),Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,MarketInfo(NULL,MODE_MAXLOT),Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUYSTOP,lots2,Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,lots2,Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
pbuy = Bid+pippoints*Point;
psell = Bid;
sit=-1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}

}

}

}

//////////////////////////NO EXPONENTIAL && NO MARTINGALE
if(EXPONENTIAL==0 && MARTINGALE==0)
{

if(Hour()==HOURBEGIN && Minute()==MINUTEBEGIN)
{inic=1;}

if(Hour()==HOURFINISH && Minute()==MINUTEFINISH)
{inic=0;
for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
{
if(!OrderDelete(OrderTicket(),Violet))
Print("OrderDelete error ",GetLastError());
}
else if(OrderType()==OP_SELL)
{
if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
else if(OrderType()==OP_BUY)
{
if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
}
}

if(inic==1)
{

   if(MarketInfo(NULL,MODE_MINLOT)==0.01){digits = 2;}
   else if(MarketInfo(NULL,MODE_MINLOT)==0.1){digits = 1;}
   else if(MarketInfo(NULL,MODE_MINLOT)==1){digits = 0;}
   spread = MarketInfo(NULL,MODE_SPREAD);
   minpipvalue = MarketInfo(NULL,MODE_TICKVALUE)*MarketInfo(NULL,MODE_MINLOT);

mpv = MarketInfo(NULL,MODE_TICKVALUE)*MarketInfo(NULL,MODE_MINLOT);
sp = MarketInfo(NULL,MODE_SPREAD);

if(sit==0)
{

if(comeco==1)
{
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUY,MarketInfo(NULL,MODE_MAXLOT),Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,MarketInfo(NULL,MODE_MAXLOT),Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUY,lots2,Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,lots2,Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);

pbuy = Ask;
psell = Ask-pippoints*Point;
sit=1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}

if(comeco==-1)
{
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,MarketInfo(NULL,MODE_MAXLOT),Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,MarketInfo(NULL,MODE_MAXLOT),Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUYSTOP,lots2,Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,lots2,Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
pbuy = Bid+pippoints*Point;
psell = Bid;
sit=-1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}
}

for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELL && sit>=1)
{
pbuy = pbuy+pippoints*Point;
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,MarketInfo(NULL,MODE_MAXLOT),pbuy,slippageOPTION,psell-pippoints*Point,0,"Hedge HFT",20000,0,Green);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUYSTOP,lots2,pbuy,slippageOPTION,psell-pippoints*Point,0,"Hedge HFT",20000,0,Green);
sit=-sit-1;
}
if(OrderType()==OP_BUY && sit<=-1)
{
psell = psell-pippoints*Point;
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket2=OrderSend(Symbol(),OP_SELLSTOP,MarketInfo(NULL,MODE_MAXLOT),psell,slippageOPTION,pbuy+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket2=OrderSend(Symbol(),OP_SELLSTOP,lots2,psell,slippageOPTION,pbuy+pippoints*Point,0,"Hedge HFT",40000,0,Red);
sit=-sit+1;
}
}

if(AccountBalance()+AccountProfit()>=Accounttp)
{
for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
{
if(!OrderDelete(OrderTicket(),Violet))
Print("OrderDelete error ",GetLastError());
}
else if(OrderType()==OP_SELL)
{
if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
else if(OrderType()==OP_BUY)
{
if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
}
if(sit>0)
{comeco = 1;}
if(sit<0)
{comeco = -1;}
sit=0;

if(comeco==1)
{
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUY,MarketInfo(NULL,MODE_MAXLOT),Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,MarketInfo(NULL,MODE_MAXLOT),Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUY,lots2,Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,lots2,Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);

pbuy = Ask;
psell = Ask-pippoints*Point;
sit=1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}

if(comeco==-1)
{
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,MarketInfo(NULL,MODE_MAXLOT),Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,MarketInfo(NULL,MODE_MAXLOT),Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUYSTOP,lots2,Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,lots2,Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
pbuy = Bid+pippoints*Point;
psell = Bid;
sit=-1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}

}

}

}

/////////////////////////////////NO EXPONENTIAL && MARTINGALE
if(EXPONENTIAL==0 && MARTINGALE==1)
{

if(Hour()==HOURBEGIN && Minute()==MINUTEBEGIN)
{inic=1;}

if(Hour()==HOURFINISH && Minute()==MINUTEFINISH)
{inic=0;
for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
{
if(!OrderDelete(OrderTicket(),Violet))
Print("OrderDelete error ",GetLastError());
}
else if(OrderType()==OP_SELL)
{
if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
else if(OrderType()==OP_BUY)
{
if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
}
}

if(inic==1)
{
   
mpv = MarketInfo(NULL,MODE_TICKVALUE)*MarketInfo(NULL,MODE_MINLOT);
sp = MarketInfo(NULL,MODE_SPREAD);

if(sit==0)
{

if(comeco==1)
{
ticket=OrderSend(Symbol(),OP_BUY,LotsIN,Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,LotsIN,Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);
pbuy = Ask;
psell = Ask-pippoints*Point;
sit=1;
Accounttp = AccountBalance()+rr*mpv*(LotsIN*100)*pippoints-mpv*sp*(LotsIN*100);
Lots=LotsIN;
}
if(comeco==-1)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,LotsIN,Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,LotsIN,Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
pbuy = Bid+pippoints*Point;
psell = Bid;
sit=-1;
Accounttp = AccountBalance()+rr*mpv*(LotsIN*100)*pippoints-mpv*sp*(LotsIN*100);
Lots=LotsIN;
}
}

for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELL && sit>=1)
{
pbuy = pbuy+pippoints*Point;
Lots=Lots*2;
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,MarketInfo(NULL,MODE_MAXLOT),pbuy,slippageOPTION,psell-pippoints*Point,0,"Hedge HFT",20000,0,Green);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUYSTOP,lots2,pbuy,slippageOPTION,psell-pippoints*Point,0,"Hedge HFT",20000,0,Green);
sit=-sit-1;
}
if(OrderType()==OP_BUY && sit<=-1)
{
psell = psell-pippoints*Point;
Lots=Lots*2;
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket2=OrderSend(Symbol(),OP_SELLSTOP,MarketInfo(NULL,MODE_MAXLOT),psell,slippageOPTION,pbuy+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket2=OrderSend(Symbol(),OP_SELLSTOP,lots2,psell,slippageOPTION,pbuy+pippoints*Point,0,"Hedge HFT",40000,0,Red);
sit=-sit+1;
}
}

if(AccountBalance()+AccountProfit()>=Accounttp)
{
for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
{
if(!OrderDelete(OrderTicket(),Violet))
Print("OrderDelete error ",GetLastError());
}
else if(OrderType()==OP_SELL)
{
if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
else if(OrderType()==OP_BUY)
{
if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
}
if(sit>0)
{comeco = 1;}
if(sit<0)
{comeco = -1;}
sit=0;

if(comeco==1)
{
ticket=OrderSend(Symbol(),OP_BUY,LotsIN,Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,LotsIN*2,Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);
pbuy = Ask;
psell = Ask-pippoints*Point;
sit=1;
Accounttp = AccountBalance()+rr*mpv*(LotsIN*100)*pippoints-mpv*sp*(LotsIN*100);
Lots=LotsIN;
}
if(comeco==-1)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,LotsIN,Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,LotsIN,Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
pbuy = Bid+pippoints*Point;
psell = Bid;
sit=-1;
Accounttp = AccountBalance()+rr*mpv*(LotsIN*100)*pippoints-mpv*sp*(LotsIN*100);
Lots=LotsIN;
}

}

}

}

//////////////////////////EXPONENTIAL && MARTINGALE
if(EXPONENTIAL==1 && MARTINGALE==1)
{

if(Hour()==HOURBEGIN && Minute()==MINUTEBEGIN)
{inic=1;}

if(Hour()==HOURFINISH && Minute()==MINUTEFINISH)
{inic=0;
for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
{
if(!OrderDelete(OrderTicket(),Violet))
Print("OrderDelete error ",GetLastError());
}
else if(OrderType()==OP_SELL)
{
if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
else if(OrderType()==OP_BUY)
{
if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
}
}

if(inic==1)
{

   if(MarketInfo(NULL,MODE_MINLOT)==0.01){digits = 2;}
   else if(MarketInfo(NULL,MODE_MINLOT)==0.1){digits = 1;}
   else if(MarketInfo(NULL,MODE_MINLOT)==1){digits = 0;}
   spread = MarketInfo(NULL,MODE_SPREAD);
   minpipvalue = MarketInfo(NULL,MODE_TICKVALUE)*MarketInfo(NULL,MODE_MINLOT);

mpv = MarketInfo(NULL,MODE_TICKVALUE)*MarketInfo(NULL,MODE_MINLOT);
sp = MarketInfo(NULL,MODE_SPREAD);

if(sit==0)
{

if(comeco==1)
{
   fator = (pippoints*Point)*(1/Point)*minpipvalue;
   Lots = NormalizeDouble(((AccountFreeMargin()*risk)/fator)*MarketInfo(Symbol(), MODE_MINLOT),digits);
   if(Lots<MarketInfo(NULL,MODE_MINLOT)){Lots=MarketInfo(NULL,MODE_MINLOT);}

lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUY,MarketInfo(NULL,MODE_MAXLOT),Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,MarketInfo(NULL,MODE_MAXLOT),Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUY,lots2,Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,lots2,Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);

pbuy = Ask;
psell = Ask-pippoints*Point;
sit=1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}

if(comeco==-1)
{
   fator = (pippoints*Point)*(1/Point)*minpipvalue;
   Lots = NormalizeDouble(((AccountFreeMargin()*risk)/fator)*MarketInfo(Symbol(), MODE_MINLOT),digits);
   if(Lots<MarketInfo(NULL,MODE_MINLOT)){Lots=MarketInfo(NULL,MODE_MINLOT);}

lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,MarketInfo(NULL,MODE_MAXLOT),Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,MarketInfo(NULL,MODE_MAXLOT),Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUYSTOP,lots2,Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,lots2,Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
pbuy = Bid+pippoints*Point;
psell = Bid;
sit=-1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}
}

for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELL && sit>=1)
{
pbuy = pbuy+pippoints*Point;
Lots=Lots*2;
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,MarketInfo(NULL,MODE_MAXLOT),pbuy,slippageOPTION,psell-pippoints*Point,0,"Hedge HFT",20000,0,Green);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUYSTOP,lots2,pbuy,slippageOPTION,psell-pippoints*Point,0,"Hedge HFT",20000,0,Green);
sit=-sit-1;
}
if(OrderType()==OP_BUY && sit<=-1)
{
psell = psell-pippoints*Point;
Lots=Lots*2;
lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket2=OrderSend(Symbol(),OP_SELLSTOP,MarketInfo(NULL,MODE_MAXLOT),psell,slippageOPTION,pbuy+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket2=OrderSend(Symbol(),OP_SELLSTOP,lots2,psell,slippageOPTION,pbuy+pippoints*Point,0,"Hedge HFT",40000,0,Red);
sit=-sit+1;
}
}

if(AccountBalance()+AccountProfit()>=Accounttp)
{
for(cnt=OrdersTotal();cnt>=0;cnt--)
{
if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
continue;
if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
{
if(!OrderDelete(OrderTicket(),Violet))
Print("OrderDelete error ",GetLastError());
}
else if(OrderType()==OP_SELL)
{
if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
else if(OrderType()==OP_BUY)
{
if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippageOPTION,Violet))
Print("OrderClose error ",GetLastError());
}
}
if(sit>0)
{comeco = 1;}
if(sit<0)
{comeco = -1;}
sit=0;

if(comeco==1)
{
   fator = (pippoints*Point)*(1/Point)*minpipvalue;
   Lots = NormalizeDouble(((AccountFreeMargin()*risk)/fator)*MarketInfo(Symbol(), MODE_MINLOT),digits);
   if(Lots<MarketInfo(NULL,MODE_MINLOT)){Lots=MarketInfo(NULL,MODE_MINLOT);}

lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUY,MarketInfo(NULL,MODE_MAXLOT),Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,MarketInfo(NULL,MODE_MAXLOT),Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUY,lots2,Ask,slippageOPTION,Ask-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELLSTOP,lots2,Ask-pippoints*Point,slippageOPTION,Ask+pippoints*Point,0,"Hedge HFT",40000,0,Red);

pbuy = Ask;
psell = Ask-pippoints*Point;
sit=1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}

if(comeco==-1)
{
   fator = (pippoints*Point)*(1/Point)*minpipvalue;
   Lots = NormalizeDouble(((AccountFreeMargin()*risk)/fator)*MarketInfo(Symbol(), MODE_MINLOT),digits);
   if(Lots<MarketInfo(NULL,MODE_MINLOT)){Lots=MarketInfo(NULL,MODE_MINLOT);}

lots2=Lots;
if(lots2>MarketInfo(NULL,MODE_MAXLOT))
{
for(n=1;n<=100000;n++)
{
ticket=OrderSend(Symbol(),OP_BUYSTOP,MarketInfo(NULL,MODE_MAXLOT),Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,MarketInfo(NULL,MODE_MAXLOT),Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
lots2=lots2-MarketInfo(NULL,MODE_MAXLOT);
if(lots2<=MarketInfo(NULL,MODE_MAXLOT))
{
break;
}
}
}
ticket=OrderSend(Symbol(),OP_BUYSTOP,lots2,Bid+pippoints*Point,slippageOPTION,Bid-pippoints*Point,0,"Hedge HFT",20000,0,Green);
ticket2=OrderSend(Symbol(),OP_SELL,lots2,Bid,slippageOPTION,Bid+pippoints*Point,0,"Hedge HFT",40000,0,Red);
pbuy = Bid+pippoints*Point;
psell = Bid;
sit=-1;
Accounttp = AccountBalance()+rr*mpv*pippoints*(Lots*100)-mpv*sp*(Lots*100);
}

}

}

}


}
//+------------------------------------------------------------------+